/*
 * Bomb.cpp
 *
 *  Created on: Jan 4, 2014
 *      Author: brian
 */



#include "Bomb.h"
#include "Game.h"

#include <vector>

Bomb::Bomb() :
		m_heading(0,0), m_caught(false), m_bExploded(false), m_bExploding(false), m_bPlayedDeathSound(false),
		m_explodingCounter(0), m_explodingTime(10){
	//m_direction = 1;
	//cout << "Bomb Constructor " << endl;

}

Bomb::~Bomb() {

	//cout << "Bomb Destructor " << endl;

}

void Bomb::playStateUpdate() {
	if (m_heading.getY() > 0) {
		m_falling = true;
		m_currentFrame = int((((SDL_GetTicks() / 100) )% 3) + 1);
	} else {
		m_currentFrame = 0;
	}
	//m_currentFrame = 0;
	m_y += m_heading.getY();
}

void Bomb::explodeStateUpdate() {
	//cout << "explodingStateUpdate: state is " << m_bExploding << endl;
	if (m_bExploding) {
		//cout << "Exploding bomb" << endl;
		m_currentFrame = int((((SDL_GetTicks() / 100) )% 2) + 4);

		m_explodingCounter++;
		if (m_explodingCounter >= m_explodingTime) {
			//cout << "Exploded bomb" << endl;
			m_bExploded = true;
		}
	} else
		m_currentFrame = int((((SDL_GetTicks() / 100) )% 3) + 1);

}

void Bomb::update() {
	switch(TheGame::Instance()->getState()) {
	case PLAY:
		playStateUpdate();
		break;
	case EXPLODE:
		explodeStateUpdate();
		break;
	case PAUSE:
		// nothing
		break;
	default:
		playStateUpdate();
	}
}

void Bomb::load(int x, int y, int width, int height, std::string textureID) {
	GameObject::load(x, y, width, height, textureID);
	//load(x, y, width, height, textureID);
}

void Bomb::draw(SDL_Renderer* pRenderer) {
	GameObject::draw(pRenderer);
}

void Bomb::clean() {
}

void Bomb::setX(int x) {
	m_x = x;
}

void Bomb::setFall(float y) {
	m_heading.setY(y);
	m_falling = true;
}

void Bomb::setExploding() {
	  TheSoundManager::Instance()->playSound("explosion",0);
	  m_bExploding = true;
}

